<?php
function cSpriteAdminMenuChecksFailed(){
 add_options_page(__('cSprites Options', 'csprites-for-wordpress'), __('cSprites', 'csprites-for-wordpress'), 8, __FILE__, 'cSpriteOptionsPageChecksFailed');
}
function cSpriteAdminMenu() {
  add_options_page(__('cSprites Options', 'csprites-for-wordpress'), __('cSprites', 'csprites-for-wordpress'), 8, __FILE__, 'cSpriteOptionsPage');
}

function cSpriteClearCache(){
  remove_action('update_option_cSpriteClearCacheNow', 'cSpriteClearCache');
  if(isset($_REQUEST['cSpriteClearCacheNow'])){
    Sprite::clearCache();
  }
  update_option('cSpriteClearCacheNow', 0);
  return 0;
}

function cSpriteOptionsPage(){

?>
<div class="wrap">


<h2><?php _e('cSprites for Wordpress', 'csprites-for-wordpress');?></h2>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>
<table class="form-table">
<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Quality & Style Settings', 'csprites-for-wordpress');?></span></td></tr>
<tr valign="top">
<th scope="row"><label for="cSpriteJpgQuality"><?php _e('JPG Quality','csprites-for-wordpress');?></label></th>
<td>
<div id="jpgCompressionSlider" style="width:300px"></div>
<?php _e('Quality', 'csprites-for-wordpress');?>: <input type="text" id="cSpriteJpgQuality" name="cSpriteJpgQuality" style="width:3em; font-weight:bold;" value="<?php echo get_option('cSpriteJpgQuality'); ?>"/>
<span class="setting-description"><?php _e('0 lowest - 100 highest (Default: 70)', 'csprites-for-wordpress');?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpritePngCompression"><?php _e('PNG Compression', 'csprites-for-wordpress');?></label></th>
<td>
<div id="pngCompressionSlider" style="width:300px"></div>
<?php echo _e('Compression', 'csprites-for-wordpress');?>: <input type="text" id="cSpritePngCompression" name="cSpritePngCompression" style="width:3em; font-weight:bold;" value="<?php echo get_option('cSpritePngCompression'); ?>"/>
<span class="setting-description"><?php _e('0 lowest - 9 highest (Default: 9)', 'csprites-for-wordpress');?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteForceNoPadding"><?php _e('Force no padding in image style', 'csprites-for-wordpress');?></label></th>
<td>
<input type="checkbox" class="cSpriteCheckbox" name="cSpriteForceNoPadding" id="cSpriteForceNoPadding" <?php echo (get_option('cSpriteForceNoPadding'))?(' checked="checked" '):('');?> />
    <span class="setting-description"><?php _e('turning this on will add a <strong>padding:0 !important;</strong> style to each image class; this will prevent padding from exposing other parts of the sprite. (Default: true)', 'csprites-for-wordpress');?></span>
    </td>
</tr>

<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Include or exclude certain image types from processing','csprites-for-wordpress');?></span></td></tr>

<tr valign="top">
<th scope="row"><label for="cSpriteProcessJpg"><?php _e('Process JPG images', 'csprites-for-wordpress');?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessJpg" id="cSpriteProcessJpg" <?php echo (get_option('cSpriteProcessJpg'))?(' checked="checked" '):('');?> />
    </td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteProcessGif"><?php _e('Process GIF images', 'csprites-for-wordpress');?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessGif" id="cSpriteProcessGif" <?php echo (get_option('cSpriteProcessGif'))?(' checked="checked" '):('');?> />
    </td>
</tr>
<tr valign="top">
<th scope="row"><label for="cSpriteProcessPng"><?php _e('Process PNG images', 'csprites-for-wordpress');?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessPng" id="cSpriteProcessPng" <?php echo (get_option('cSpriteProcessPng'))?(' checked="checked" '):('');?> />
    <span class="setting-description"><?php _e('Due to the way PHP handles PNG files, the resulting sprite may be larger than the sum of the original file sizes', 'csprites-for-wordpress');?></span>
    </td>
</tr>

<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Cache Settings','csprites-for-wordpress');?></span></td></tr>

<tr valign="top">
<th scope="row"><label for="cSpriteCacheTime"><?php _e('Cache Time in Minutes', 'csprites-for-wordpress');?></label></th>
<td><input type="text" name="cSpriteCacheTime" id="cSpriteCacheTime" value="<?php echo get_option('cSpriteCacheTime'); ?>" style="width:6em;"/><span class="setting-description"><?php _e('set to 0 for no cache (Default: 20)', 'csprites-for-wordpress');?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteClearCacheNow"><?php _e('Clear cSprite Cache', 'csprites-for-wordpress');?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteClearCacheNow" id="cSpriteClearCacheNow"/>
    <span class="setting-description"><?php _e('Immediately deletes all the files in the cSprite cache. May help with images not displaying properly.', 'csprites-for-wordpress');?></span>
    </td>
</tr>

</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="cSpriteJpgQuality,cSpritePngCompression,cSpriteCacheTime,cSpriteForceNoPadding,cSpriteClearCacheNow,cSpriteProcessJpg,cSpriteProcessPng,cSpriteProcessGif" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes', 'csprites-for-wordpress') ?>" />
</p>

</form>
</div>
<?php 
} //end function 

function cSpriteOptionsPageChecksFailed(){
?>
<div class="wrap">
<h2><?php _e('cSprites for Wordpress', 'csprites-for-wordpress');?></h2>
<h3><?php _e('The following problems occurred in your installation', 'csprites-for-wordpress');?>:</h3>
<?php if(!cSpriteCheckCacheWritable()):?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>The directory: <strong><em><?php echo CSPRITE_CACHE_DIR; ?></em></strong> was not writable. Please modify permissions.</p></div>
<?php endif; ?>
<?php if(!cSpriteCheckPhpVersion()): ?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>You are currently running PHP <strong><?php echo phpversion(); ?></strong>. cSprites only supports PHP versions &gt; <strong>5.0.0</strong></p></div>
<?php endif; ?>
<?php if(!cSpriteCheckWordPressVersion()): ?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>You are currently running an unsupported version of Wordpress. cSprites only supports Wordpress versions &gt;= <strong>2.7</strong></p></div>
<?php endif; ?>

<h4><?php _e('In order to run cSprites please fix these problems and refresh this screen.', 'csprites-for-wordpress');?></h4>
<?php
}

function cSpriteWriteScripts(){
  $cSpriteJpgQuality = (get_option('cSpriteJpgQuality')!== null)?(get_option('cSpriteJpgQuality')):('70');
  $cSpritePngCompression = (get_option('cSpritePngCompression')!== null)?(get_option('cSpritePngCompression')):('9');

  $scripts = '<script type="text/javascript" src="'.CSPRITE_PLUGIN_URL.'/includes/interface/jquery.checkbox.js"></script>'."\n";
  $scripts .= '<script type="text/javascript" src="'.CSPRITE_PLUGIN_URL.'/includes/interface/jquery-ui-1.5.3.custom.min.js"></script>'."\n";

  $scripts .= "<script>
  
  jQuery.noConflict();

	jQuery(document).ready(function() {
				jQuery('input[type=checkbox].cSpriteCheckbox').checkbox({
  cls:'jquery-checkbox',
  empty: '".CSPRITE_PLUGIN_URL."/1_1_trans.gif'
});
				jQuery('a.code').each(function() {
					jQuery(this).click(function(){
						eval(jQuery(this).text());
						return false;
					})
				});
      
      jQuery('#jpgCompressionSlider').slider({
			 value: ".$cSpriteJpgQuality.",
			 min: 0,
			 max: 100,
			 step: 1,
			 slide: function(event, ui) {
				jQuery('#cSpriteJpgQuality').val(ui.value);
			 }
		});
		jQuery('#jpgCompressionSlider').slider('moveTo', ".$cSpriteJpgQuality.", null, false);
		jQuery('#cSpriteJpgQuality').val(jQuery('#jpgCompressionSlider').slider('value'));
		
		jQuery('#pngCompressionSlider').slider({
			 value: ".$cSpritePngCompression.",
			 min: 0,
			 max: 9,
			 step: 1,
			 slide: function(event, ui) {
				jQuery('#cSpritePngCompression').val(ui.value);
			 }
		});
		jQuery('#pngCompressionSlider').slider('moveTo', ".$cSpritePngCompression.", null, false);
		jQuery('#cSpritePngCompression').val(jQuery('#pngCompressionSlider').slider('value'));
  });
  
</script>";
echo $scripts;
}
?>