<?php
/*
Plugin Name: cSprites for Wordpress
Plugin URI: http://wordpress.org/extend/plugins/csprites-for-wordpress/
Description: Automatically compress you content images into a big sprite, decreasing web page load time.
Version: 0.502
Author: Adrian Mummey
Author URI: http://mummey.org/
Copyright 2008-2009 Adrian Mummey

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }

function cSpriteFindImg($content){
  $matches = array();
  $imgs = preg_match_all("/<img[^>]* src=('|\")([^\"^']*)('|\")[^>]*>/i", $content, $matches);
  if(isset($matches[2])){
    foreach($matches[2] as $imgSource){
      $imgSource = (SpriteImageRegistry::is_url($imgSource))?($imgSource):(cSpriteCleanUrl($imgSource));      
      SpritePreprocessorCache::addOriginalImageSource($imgSource);
    }
  }  
  if(isset($matches[0])){
    foreach($matches[0] as $imgTag){
      SpritePreprocessorCache::addOriginalImageTag($imgTag);
    }
  }
}
function cSpriteImgReplace($content){
  $matches = array();
  $pattern = array();
  /*$img_regex = '/<img[\s]+[^>]*?((class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?)|(src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?))((src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?>)|(class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?>)|>)/i';*/
  $img_regex = '/<img[\s]+[^>]*?(.*?)((class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?)|(src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?))(.*?)((src*?[\s]?=[\s\"\']+(.*?)[\"\']+(.*?)>)|(class*?[\s]?=[\s\"\']+(.*?)[\"\']+(.*?)>)|>)/i';
  $content = preg_replace_callback($img_regex, 'cSpriteReplacement', $content);
  return $content;
}
function cSpriteReplacement($matches){
  $blankGif = SpriteConfig::get('transparentImagePath');
  if(@$matches[13]){
    $src = $matches[6];
    $src = (SpriteImageRegistry::is_url($src))?($src):(cSpriteCleanUrl($src));
    $class = $matches[13];
    //$spriteClass = Sprite::styleClass($src);
    $spriteClass = SpritePreprocessorCache::getImageClass($src);
    if(!$spriteClass){
      return $matches[0];
    }
    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$class.' '.$spriteClass.'" '.$matches[7].' ' .$matches[14].'/>';
  }
  else if(@$matches[10]){
    $src = $matches[10];
    $src = (SpriteImageRegistry::is_url($src))?($src):(cSpriteCleanUrl($src));    
    $class = $matches[4];
    //$spriteClass = Sprite::styleClass($src);
    $spriteClass = SpritePreprocessorCache::getImageClass($src);
    if(!$spriteClass){
      return $matches[0];
    }
    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$class.' '.$spriteClass.'" '.$matches[7].' ' .$matches[11].'/>';
  }
  else{
    $src = $matches[6];
    $src = (SpriteImageRegistry::is_url($src))?($src):(cSpriteCleanUrl($src));    
    //$spriteClass = Sprite::styleClass($src);
    $spriteClass = SpritePreprocessorCache::getImageClass($src);
    if(!$spriteClass){
      return $matches[0];
    }

    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$spriteClass.'" '.$matches[7].'/>';
  }
  return $returnString;
}
function cspriteStyles(){
	$cstyles = "
	<!-- begin wpcsprites scripts -->
	<script type=\"text/javascript\">
    //<![CDATA[
    document.write('<link rel=\"stylesheet\" href=\"". get_bloginfo('wpurl')."/wp-content/plugins/csprites-for-wordpress".SpritePreprocessorCache::getCssFile()."\" type=\"text/css\" media=\"screen\" />');
    //]]>
    </script>
	<!-- end wpcsprites scripts -->\n";
  echo $cstyles; 

}

function updatecSpriteOptions(){
  $imagePropertiesOrig = SpriteConfig::get('imageProperties');
  add_option('cSpriteJpgQuality', $imagePropertiesOrig['jpgQuality']);
  add_option('cSpritePngCompression', $imagePropertiesOrig['pngCompression']);
  add_option('cSpriteCacheTime', SpriteConfig::get('cacheTime'));
  add_option('cSpriteForceNoPadding', SpriteConfig::get('forceNoPadding'));
  add_option('cSpriteClearCacheNow', '');
  add_option('cSpriteProcessPng', 1);
  add_option('cSpriteProcessJpg', 1);
  add_option('cSpriteProcessGif', 1);
  
  $imageProperties['jpgQuality'] = (is_numeric(get_option('cSpriteJpgQuality')))?(get_option('cSpriteJpgQuality')):($imagePropertiesOrig['jpgQuality']);
  $imageProperties['pngCompression'] = (is_numeric(get_option('cSpritePngCompression')))?(get_option('cSpritePngCompression')):($imagePropertiesOrig['pngCompression']);
  $acceptedTypes = array();
  if(get_option('cSpriteProcessPng')){
    $acceptedTypes[] = 'png';
  }
  if(get_option('cSpriteProcessJpg')){
    $acceptedTypes[] = 'jpg';
    $acceptedTypes[] = 'jpeg';    
  }
  if(get_option('cSpriteProcessGif')){
    $acceptedTypes[] = 'gif';
  }
  SpriteConfig::set('acceptedTypes', $acceptedTypes);
  SpriteConfig::set('imageProperties', $imageProperties);
  SpriteConfig::set('cacheTime', (is_numeric(get_option('cacheTime')))?(get_option('cSpriteCacheTime')):(20));
  SpriteConfig::set('forceNoPadding', get_option('cSpriteForceNoPadding'));
}

function cSpriteLoopStart(){
  global $wp_query;
  
  if(in_the_loop() && !is_admin()){
    $the_posts = $wp_query->posts;
    foreach($the_posts as $post){
      $content = $post->post_content;
    	$content = apply_filters('the_content', $content);
    	$content = str_replace(']]>', ']]&gt;', $content);
    	$content = do_shortcode($content);
      cSpriteFindImg($content);
    }
    if(SpritePreprocessorCache::preprocessorCacheNeedsCreation()){
        SpritePreprocessorCache::registerImageSources();
        Sprite::process();
    }
    add_filter('the_content', 'cSpriteImgReplace',50);
  }
  
}

function cSpriteLoopEnd(){
 // Sprite::reset();
}

function cSpriteCleanUrl($url){
  if(@$url[0] != '/'){
    $url = '/'.$url;
  }
  return get_bloginfo('wpurl').$url;
}

function cSpriteCheckCacheWritable(){
  $file = CSPRITE_CACHE_DIR.'/permission.txt'; 
  return (@file_put_contents($file, 'sanity check') !== false);
}

function cSpriteCheckPhpVersion(){
  return version_compare(PHP_VERSION, '5.0.0', '>');
}

function cSpriteCheckWordPressVersion(){
  global $wp_version;
  $minimum_wp = '2.7';
  return version_compare($wp_version, $minimum_wp, '>=');
}

function cSpritePreflightChecks(){
  return cSpriteCheckCacheWritable() && cSpriteCheckPhpVersion() && cSpriteCheckWordPressVersion();
}
function cSpriteWriteCssCache(){
  if(!is_admin()){
    try{
      SpritePreprocessorCache::writeCachedAttributes();
    }
    catch(SpriteException $e){}
  }
}

function startcSprites(){
  /*cSprites config*/
  define('CSPRITE_PLUGIN_NAME', basename(dirname(__FILE__)));
  define('CSPRITE_PLUGIN_DIR', WP_PLUGIN_DIR.'/'.CSPRITE_PLUGIN_NAME);
  define('CSPRITE_PLUGIN_URL', WP_PLUGIN_URL.'/'.CSPRITE_PLUGIN_NAME);
  define('SPRITE_CONFIG_FILE', CSPRITE_PLUGIN_DIR.'/config.yml');
  define('CSPRITE_CACHE_DIR', CSPRITE_PLUGIN_DIR.'/cache');
  require_once('includes/options.php');
  require_once('includes/uninstall.php');

  load_plugin_textdomain( 'csprites-for-wordpress', 'wp-content/plugins/'.CSPRITE_PLUGIN_NAME.'/lang', CSPRITE_PLUGIN_NAME );
  
  if (cSpritePreflightChecks()) {  
    /*Init global vars*/
    require_once('csprites/Sprite.php');
    SpriteConfig::set('rootDir', CSPRITE_PLUGIN_DIR);
    SpriteConfig::set('transparentImagePath', CSPRITE_PLUGIN_URL.'/1_1_trans.gif');
    SpriteConfig::set('cssImagePath', CSPRITE_PLUGIN_URL);
    
    if(!is_admin()){
      add_action('wp_footer', 'cspriteStyles');
      add_action('loop_start', 'cSpriteLoopStart');
      add_action('loop_end', 'cSpriteLoopEnd');  
      add_action('shutdown', 'cSpriteWriteCssCache');
    }
    else{
      add_action('update_option_cSpriteClearCacheNow', 'cSpriteClearCache');
      add_action('admin_menu', 'cSpriteAdminMenu');
      wp_register_style('cSpritesAdminStyles', CSPRITE_PLUGIN_URL.'/includes/interface/csprites.min.css', array(), '', 'screen');
      wp_enqueue_style('cSpritesAdminStyles');
      
      add_action('admin_head', 'wp_print_styles', '100');
      add_action('admin_head', 'cSpriteWriteScripts');
    }
    updatecSpriteOptions();  
  }
  else{
    add_action('admin_menu', 'cSpriteAdminMenuChecksFailed');
  }

}
add_action('plugins_loaded', 'startcSprites');
//wp_enqueue_style('test.css');



?>